/*
 *	蔲j[ Ver0.1
 */

#include "mytypes.h"
#include "syscall.h"
#include "menuwin.h"

void doAR3bank0(void);
void doAR3bank1(void);
void doCopy8000(void);
void doCopyAR(void);
void doDetectROM(void);

static void InitAll(void);

int CurrentFrame = 1;	/* 01 */
#define OFFSCREEN_Y()	( (CurrentFrame << 8) + (IS_SCEE() << 3) )
#define ONSCREEN_Y()	( ((CurrentFrame ^ 1) << 8) + (IS_SCEE() << 3) )
#define TOGGLE_SCREEN()	{ CurrentFrame ^= 1; }

typedef struct {
	enum {
		PROCTYPE_EXEC,
		PROCTYPE_CALL,
	} procType;
	void *procedure;
} PROCEDURE;

uchar PadBuf[9];

int main(int argc, char **argv)
{
	int c;
	MENUWIN win;
	MENUDEF menus[8];
	PROCEDURE procs[] = {
/***	{ PROCTYPE_EXEC, "cdrom:\\ARGON.EXE;1" },
		{ PROCTYPE_EXEC, "cdrom:\\CDAR.PSX;1" },
****/
		{ PROCTYPE_EXEC, "cdrom:\\AR3FLASH.EXE;1" },
		{ PROCTYPE_EXEC, "cdrom:\\HD.EXE;1" },
		
		{ PROCTYPE_CALL, doAR3bank0 },
		{ PROCTYPE_CALL, doAR3bank1 },

		{ PROCTYPE_CALL, doCopy8000 },
		{ PROCTYPE_CALL, doCopyAR },
		{ PROCTYPE_CALL, doDetectROM }
	};
	int n;
	RECT rect = { 0, 0, 320, 240 };
	int changed;
	int wait;

	n = 0;
	menus[n].title = "RUN AR3 REFLASH TOOL";
	menus[n].user = &procs[n];
	n ++;

	menus[n].title = "RUN HexDump/Disassembler";
	menus[n].user = &procs[n];
	n ++;

	menus[n].title = "Change Bank of AR3 to 0";
	menus[n].user = &procs[n];
	n ++;

	menus[n].title = "Change Bank of AR3 to 1";
	menus[n].user = &procs[n];
	n ++;

	menus[n].title = "COPY 80000000-ffff to 80030000";
	menus[n].user = &procs[n];
	n ++;

	menus[n].title = "COPY 1f000000-7ffff to 80040000";
	menus[n].user = &procs[n];
	n ++;

	menus[n].title = "VIEW EEPROM ID(not for AR3)";
	menus[n].user = &procs[n];
	n ++;

	menus[n].title = NULL;
	menus[n].user = NULL;

	InitAll();
	GPU_sync();
	CD_Control(7);

	sendGPU(0x03000000, true);	/* ʕ\ */
	bogoVSyncWait2(PadBuf, 20);

	FontPuts("AR3 REFLASHER 0.30 MENU",
		MKRGB15(0x00, 0x80, 0x00), MKRGB15(0,0,0),
		MKSHORT_YX(ONSCREEN_Y() + 20, 20)
		);

	MenuWinInit(&win, 20, 64, 280, 144, menus);
	win.fg = 0x00008000;
	win.fg_active = 0x0000ffff;
	win.bg_active = 0x00000000;
	
	bogoVSyncWait2(PadBuf, 1);
	MenuWinRedraw(&win, 0, ONSCREEN_Y());
	GPU_sync();
	CopyImage(&rect, 0, 256);
	bogoVSyncWait2(PadBuf, 1);
	sendGPU(0x05000000 | 0 | (ONSCREEN_Y() << 10), true); 	/* \̈n_ */

#define KEY_WAIT_DEFAULT	10
#define KEY_WAIT_RAPID		5

	for (changed = 0 ;;) {
		bogoVSyncWait2(PadBuf, 1);
		/*** ez-O-ray ̒ʐM ***/
		c = CheckComms();
		if (c == 'W') {
			ChatComms_W();
		} else if (c == 'i') {
			ChatComms_i();
		}


		if (changed) {
			changed = 0;
			TOGGLE_SCREEN();
			sendGPU(0x05000000 | 0 | ONSCREEN_Y() << 10, true); 	/* \̈n_ */
			/* ʂɂȂɕ\ʂRs[ */
			rect.y = ONSCREEN_Y();
			CopyImage(&rect, 0, OFFSCREEN_Y());
			bogoVSyncWait2(PadBuf, wait);
			wait = KEY_WAIT_RAPID;
		} else wait = KEY_WAIT_DEFAULT;

		if (PADIS_DOWN(PadBuf)) {
			MenuWinMoveCursor(&win, 1, 0, OFFSCREEN_Y());
			changed ++;
		} else if (PADIS_UP(PadBuf)) {
			MenuWinMoveCursor(&win, -1, 0, OFFSCREEN_Y());
			changed ++;
		} else if (PADIS_CIRCLE(PadBuf)) {
			PROCEDURE *p = (PROCEDURE *)menus[(int)win.base + win.pos].user;
			if (p->procType == PROCTYPE_EXEC) {
				printf("[%s]\n", p->procedure);
				LoadExec(p->procedure, 0x801ffff0, 0);
				/* Ă񂾂Ƃ͂ǁ[ł */
			} else if (p->procType == PROCTYPE_CALL) {
				((void (*)(void))p->procedure)();
			}
		}
	}
	return 0;
}


static void InitAll(void)
{
	int pal;
	
	ExitCriticalSection();

	ResetEntryInt();
	
	bzero(PadBuf, sizeof (PadBuf));	/* pbḧ揉 */
	InitPAD(PadBuf, sizeof (PadBuf), NULL, 0);
	
	/* GPU */
	sendGPU(0, true);							/* Zbg */
	sendGPU(0x03000001, true);					/* ʕ\ OFF */

	pal = IS_SCEE();
	sendGPU(0x05000000 | 0 | ((pal ? 0:8) << 10), true); 	/* \̈n_ 0,0 */

	sendGPU(0x06c60260, true);					/* \͈ */
	sendGPU(pal ? 0x07048030 : 0x07040010, true);	/* \͈ */
	/* 320x240 NTSC/PAL 16bit non interlace */
	sendGPU(0x08000000 | 1 | ( pal ? 8 : 0 ), true);

	GPU_cw(0xe1000400);	/* `惂[hi\̈ɕ` fBUȂ tpage0j*/
	GPU_cw(0xe3000000);	/* `̈n_ (0,0) */
	GPU_cw(0xe407ffff);	/* `̈I_ (1023,511) */
	GPU_cw(0xe5000000);	/* `ItZbg (0,0) */
	
	ClearScreen(MKRGB24(0,0,0));

	StartPAD();

	return;
}

void doDetectROM(void)
{
	uchar orig[2];
	ulong rc;
	uchar *romPtr;
	int i;
	int x;
	const char hex[] = "0123456789abcdef";
	RECT rect = { 0, 0, 320, 240 };
	
	extern ulong ArGetRomType(ulong romAddr);	/* detect2.s */

				/*	01234567890123456789012345678901234567890 */
	char str0[] =  "ROM#             :  0  1  2  3";
	char str1[] =  "1f0x0000         : xx xx xx xx";
	char str2[] =  "Manufacturer     : xx xx xx xx";
	char str3[] =  "M(OLD SST METHOD): xx xx xx xx";
	char str4[] =  "1f0x0001         : xx xx xx xx";
	char str5[] =  "Device           : xx xx xx xx";
	char str6[] =  "D(OLD SST METHOD): xx xx xx xx";

	/* 1f0x0000,0001 */
	x = 19;
	romPtr = (uchar *)0x1f000000;
	for (i = 0 ; i < 4 ; i ++) {
		orig[0] = romPtr[0];
		orig[1] = romPtr[1];

		str1[x] = hex[(orig[0] >> 4) & 0x0f];
		str4[x] = hex[(orig[1] >> 4) & 0x0f];
		x ++;
		str1[x] = hex[orig[0] & 0x0f];
		str4[x] = hex[orig[1] & 0x0f];
		x += 2;
		romPtr += 0x20000;
	}
	x = 19;
	romPtr = (uchar *)0x1f000000;
	EnterCriticalSection();
	for (i = 0 ; i < 4 ; i ++) {
		rc = ArGetRomType((ulong)romPtr);

		str2[x] = hex[(rc >> 4) & 0x0f];
		str5[x] = hex[(rc >> 12) & 0x0f];
		str3[x] = hex[(rc >> 20) & 0x0f];
		str6[x] = hex[(rc >> 28) & 0x0f];

		x ++;
		
		str2[x] = hex[rc & 0x0f];
		str5[x] = hex[(rc >> 8) & 0x0f];
		str3[x] = hex[(rc >> 16) & 0x0f];
		str6[x] = hex[(rc >> 24) & 0x0f];

		x += 2;
		romPtr += 0x20000;
	}
	ExitCriticalSection();

	/* \ */
	TOGGLE_SCREEN();
	sendGPU(0x05000000 | 0 | ONSCREEN_Y() << 10, true); 	/* \̈n_ */
	FontPuts(str0, MKRGB15(0x00, 0x00, 0x00), MKRGB15(0xff,0xff,0xff),
		MKSHORT_YX(ONSCREEN_Y() + 64, (320-8*29)>>1) );
	FontPuts(str1, MKRGB15(0x00, 0x00, 0x00), MKRGB15(0xff,0xff,0xff),
		MKSHORT_YX(ONSCREEN_Y() + 64 + 16, (320-8*29)>>1) );
	FontPuts(str2, MKRGB15(0x00, 0x00, 0x00), MKRGB15(0xff,0xff,0xff),
		MKSHORT_YX(ONSCREEN_Y() + 64 + 32, (320-8*29)>>1) );
	FontPuts(str3, MKRGB15(0x00, 0x00, 0x00), MKRGB15(0xff,0xff,0xff),
		MKSHORT_YX(ONSCREEN_Y() + 64 + 48, (320-8*29)>>1) );
	FontPuts(str4, MKRGB15(0x00, 0x00, 0x00), MKRGB15(0xff,0xff,0xff),
		MKSHORT_YX(ONSCREEN_Y() + 64 + 64, (320-8*29)>>1) );
	FontPuts(str5, MKRGB15(0x00, 0x00, 0x00), MKRGB15(0xff,0xff,0xff),
		MKSHORT_YX(ONSCREEN_Y() + 64 + 80, (320-8*29)>>1) );
	FontPuts(str6, MKRGB15(0x00, 0x00, 0x00), MKRGB15(0xff,0xff,0xff),
		MKSHORT_YX(ONSCREEN_Y() + 64 + 96, (320-8*29)>>1) );

	GPU_sync();
	waitButtonRelease(PadBuf);
	for (;;) {
		bogoVSyncWait2(PadBuf, 1);
		if (PADIS_CIRCLE(PadBuf)) break;
	}
	waitButtonRelease(PadBuf);
	
	TOGGLE_SCREEN();
	sendGPU(0x05000000 | 0 | ONSCREEN_Y() << 10, true); 	/* \̈n_ */
	/* ʂɂȂɕ\ʂRs[ */
	rect.y = ONSCREEN_Y();
	CopyImage(&rect, 0, OFFSCREEN_Y());
	GPU_sync();

	return;
}

void doCopy8000(void)
{
	ulong *src, *dest;
	ulong *srcEnd;
	RECT rect = { 0, 0, 320, 240 };

	/* ܂ 80000000  10000 oCg 80030000 ɃRs[ */
	src = (ulong *)0x80000000;
	dest = (ulong *)0x80030000;
	srcEnd = (ulong *)0x80010000;
	while (src < srcEnd) *dest ++ = *src ++;

	TOGGLE_SCREEN();
	sendGPU(0x05000000 | 0 | ONSCREEN_Y() << 10, true); 	/* \̈n_ */

	FontPuts("80000000 -> 80030000",
		MKRGB15(0x00, 0x00, 0x00), MKRGB15(0xff,0xff,0xff),
		MKSHORT_YX(ONSCREEN_Y() + 104, (320-8*20)>>1)
		);
	GPU_sync();
	waitButtonRelease(PadBuf);
	for (;;) {
		bogoVSyncWait2(PadBuf, 1);
		if (PADIS_CIRCLE(PadBuf)) break;
	}
	waitButtonRelease(PadBuf);
	
	TOGGLE_SCREEN();
	sendGPU(0x05000000 | 0 | ONSCREEN_Y() << 10, true); 	/* \̈n_ */
	/* ʂɂȂɕ\ʂRs[ */
	rect.y = ONSCREEN_Y();
	CopyImage(&rect, 0, OFFSCREEN_Y());
	GPU_sync();

	return;
}

void doCopyAR(void)
{
	ulong *src, *dest;
	ulong *srcEnd;
	RECT rect = { 0, 0, 320, 240 };

	/*  1f000000  80000 oCg 80040000 ɃRs[ */
	src = (ulong *)0x1f000000;
	dest = (ulong *)0x80040000;
	srcEnd = (ulong *)0x1f080000;
	while (src < srcEnd) *dest ++ = *src ++;

	TOGGLE_SCREEN();
	sendGPU(0x05000000 | 0 | ONSCREEN_Y() << 10, true); 	/* \̈n_ */

	FontPuts("1f000000 -> 80040000",
		MKRGB15(0x00, 0x00, 0x00), MKRGB15(0xff,0xff,0xff),
		MKSHORT_YX(ONSCREEN_Y() + 104, (320-8*20)>>1)
		);
	GPU_sync();
	waitButtonRelease(PadBuf);
	for (;;) {
		bogoVSyncWait2(PadBuf, 1);
		if (PADIS_CIRCLE(PadBuf)) break;
	}
	waitButtonRelease(PadBuf);
	
	TOGGLE_SCREEN();
	sendGPU(0x05000000 | 0 | ONSCREEN_Y() << 10, true); 	/* \̈n_ */
	/* ʂɂȂɕ\ʂRs[ */
	rect.y = ONSCREEN_Y();
	CopyImage(&rect, 0, OFFSCREEN_Y());
	GPU_sync();

	return;
}

/*
 *	oN؂ւ̃eXg
 *	ʏN͉zJANeBu݂ȂŁA
 *	tɂĂ݂邩B
 */
void doAR3bank0(void)
{
	char *dest = (char *)0x1f060030;
	*dest = 3;
}

void doAR3bank1(void)
{
	char *dest = (char *)0x1f060030;
	*dest = 1;
}

