#include "menuwin.h"
#include "gpupkt.h"

#define ISKANJI1(c)	( ((c) > 0x80 && (c) < 0xa1) || ((c) > 0xdf && (c) < 0xfe) )

void MenuWinInit(MENUWIN *pWin, short x, short y, short w, short h, MENUDEF *menus)
{
	short i;
	
	pWin->x = x;
	pWin->y = y;
	pWin->w = w;
	pWin->h = h;
	pWin->base = 0;
	pWin->pos = 0;
	pWin->items = menus;
	
	for (i = 0 ; menus[i].title != NULL ; i ++);
	pWin->numItem = i;

	pWin->charW = w / MW_CHAR_WIDTH;	/* ACRt̂Ƃ͂Pւ炷 */
	pWin->charH = h / MW_CHAR_HEIGHT;

	/* ftHg̐Fݒ */
	pWin->bg = 0x00000000;	/* black */
	pWin->fg = 0x00ffffff;	/* white */
	pWin->bg_active = 0x00ffffff;	/* white */
	pWin->fg_active = 0x00000000;	/* black */
	pWin->flags = 0;
	
	pWin->numIcon = 0;
	pWin->curIcon = 0;
	pWin->waitCount = 0;
	pWin->icons = 0;
	
	return;
}

void MenuWinRedraw(MENUWIN *pWin, short baseX, short baseY)
{
	int i;
	RECT rect;


	rect.x = pWin->x + baseX;
	rect.y = pWin->y + baseY;
	rect.w = pWin->w;
	rect.h = pWin->h;
	/* ֐dl킷ꂽI */
//	FillRect(&rect, pWin->bg);

	for (i = 0 ; i < pWin->charH ; i ++) {
		MenuWinDrawItem(pWin, i, baseX, baseY);
	}
	return;
}

void MenuWinDrawItem(MENUWIN *pWin, int n, short baseX, short baseY)
{
	unsigned long fg, bg;
	short charW;
	short x, y;
	char buf[64 + 1];
	int i;
	unsigned char *str;
	
	fg = (pWin->pos == n) ? pWin->fg_active : pWin->fg;
	bg = (pWin->pos == n) ? pWin->bg_active : pWin->bg;

	x = baseX + pWin->x;
	y = baseY + pWin->y + MW_CHAR_HEIGHT * n;
	
	charW = pWin->charW;
	if (MWIN_HASICON(pWin)) {
		charW -= 2;
		x += MW_CHAR_HEIGHT;	/* MW_CHAR_HEIGHT ̐`[ɂ */
	}
	/* \镶 buf ɐ؂oB{̐؂ڂɒӁB */
	str = pWin->items[pWin->base + n].title;
	
	for (i = 0 ; i < charW ; ) {
		if (str[i] == '\0') break;
		if (ISKANJI1(str[i])) {
			if (i + 1 >= charW) break;
			buf[i] = str[i]; i ++;
			buf[i] = str[i]; i ++;
		} else {
			buf[i] = str[i]; i ++;
		}
	}
	while (i < charW) buf[i ++] = ' ';
	buf[charW] = '\0';

	FontPuts(buf, RGB24to15(fg), RGB24to15(bg), MKSHORT_YX(y, x));
	
	/* ACR邩H */
	if (MWIN_HASICON(pWin)) {
		RECT rect;
		/* Ƃ肠 bg FŖ߂ĂB */
		rect.x = baseX + pWin->x;
		rect.y = baseY + pWin->y + MW_CHAR_HEIGHT * n;
		rect.w = rect.h = MW_CHAR_HEIGHT;

		FillRect(&rect, bg);
	}

	return;
}

int MenuWinMoveCursor(MENUWIN *pWin, int bector, short baseX, short baseY)
{
	short newPos;
	int carry = 0;
	short s;
	
	newPos = pWin->base + pWin->pos + bector;
	if (newPos < 0) {
		carry ++;
		newPos = 0;
	}
	if (newPos >= pWin->numItem) {
		carry ++;
		newPos = pWin->numItem - 1;
	}
	/* \͈͓ł̈ړ̏ꍇ */
	s = newPos - pWin->base;
	if (s >= 0 && s < pWin->charH) {
		newPos = s;
		s = pWin->pos;
		pWin->pos = newPos;
		MenuWinDrawItem(pWin, s, baseX, baseY);
		MenuWinDrawItem(pWin, newPos, baseX, baseY);
	} else {
		/* y[Wړ */
		s = newPos - pWin->pos;
		if (s < 0) s = 0;
		if (s > pWin->numItem - pWin->charH) s = pWin->numItem - pWin->charH;
		pWin->base = s;
		pWin->pos = newPos - s;
		
		MenuWinRedraw(pWin, baseX, baseY);
	}
	
	return carry;
}

/*
 *	J[\ACR`iXVj
 */
void MenuWinUpdatePointer(MENUWIN *pWin, short baseX, short baseY)
{
	MENUPOINTER *pIcon;
	short x, y;
	
	if (MWIN_HASICON(pWin) == 0) return;
	
	pWin->waitCount --;
	
	if (pWin->waitCount < 0) {
		/* ̃ACRɈړ */
		if (pWin->curIcon == pWin->numIcon) {
			pWin->curIcon = 0;
		} else pWin->curIcon ++;
		
		pWin->waitCount = pWin->icons[pWin->curIcon].waitCount;
	}
	
	pIcon = &pWin->icons[pWin->curIcon];	/* \ACR */

	x = pWin->x + baseX;
	y = pWin->y + baseY + MW_CHAR_HEIGHT * pWin->pos;
	
	/* eNX`t|SSp`` */
	/* x */

	return;
}

/*
 *	width ̐^񒆂 fg FŒ`
 */
void MenuDecorate_simple(MENUWIN *pWin, short width, RGB24 fg, RGB24 bg,
	short baseX, short baseY)
{
	short x, y;
	RECT rect;
	
	rect.y = pWin->y + baseY - (width >> 1);
	rect.x = pWin->x + baseX - (width >> 1);
	rect.w = pWin->w + width;
	rect.h = pWin->h + width;
	DrawRect(&rect, fg);
	rect.x ++; rect.y ++;
	GPU_sync();
	DrawRect(&rect, bg);
	
	return;
}

